#QUICK REFERENCE PYTHON CODE

#initializations
import os; import sys; import re; import time as tm; #for inputs, i/o files, time and regex
import pandas as pd; import numpy as np; from matplotlib import pyplot as mp; from mpl_toolkits.mplot3d import Axes3D; #for data manipulation and visualization
from scipy import stats as st; import sklearn as ml; #for stats and machine learning

#variables
n=43; #number
s="simple string"; s.replace('sim', 'sam'); s.rstrip(); As=s.split(','); #string (char index, modify)
Al=['string', 43, 18, 104]; Al.pop(); Al.remove(43); Al.insert(0,'ok');  #array (number index, modify)
Hd={'name':'fabio','age':32}; Hd.pop('name');  Hd.values();  Hd.keys(); #hash, (string index, modify) 
Tx=(1, 2, 3, '100'); #tuple (number index, fixed, saves memory) 
Sx={'primo','secondo','dolce'}; Sx.intersection(Sx); Sx.difference(Sx); Sx.union(Sx) #set

#methods
dir() #lists all the variables and functions in the memory
dir(Tx) #lists all methods available for the variable
del n #delete a variable from memory
type(s) #returns the class of the variable

#string format
n='john'; m=32; string=f"{n} is {m} years old"; #variables in string
rawstr=r"C:\Users\Fabio\Downloads\file.csv"; #read string as it is

#inputs
sys.argv[0]; #input from command line (sys)
sin=input(); sin=sin.rstrip(); #input from stdin
path=sin.split('\\'); f=path.pop(); dir='/'.join(path); os.chdir(dir); #split and go to dir (os)

#i/o files
o=open(sin); s=o.read(); #in file in a string, loading in memory 
o=open(sin); Al=o.read().splitlines(); #read lines of file in array, loading in memory
o.write('string'); o.close(); #write to file and close
with open(r'C:\Users\Fabio\Downloads\file.csv') as fh: #process file line by line not consuming memory
 for l in fh: 
  Ai=l.rstrip().split(','); 
  print(l, file=open(r'E:\work\py36\py.out', "a"));  

#i/o folders
for f in os.listdir(path): #iterates on files in a folder
 current = os.path.join(path, f)
 if os.path.isfile(current): 
  data = open(current, "rb") 
  print(len(data.read())); 

#time check
date=tm.time(); #return unix epoch

#system control
os.system("wget --no-check-certificate --user-agent=Chrome/57.0.2987.93 -O file.out -q https://en.wikipedia.org/wiki/Italy"); #use wget
os.system('cls'); #clear screen

#syntax
A=[1,2,3,4];
for x in A:
 print(x);

a = 33
b = 200
if b > a:
 print("b is greater than a")
elif a == b:
 print("a and b are equal")
else:
 print("a is greater than b")

i = 1
while i < 6:
 print(i)
 if i == 3:
 break
  i += 1

#regex
s='''
regex for matching patters in strings of text
metacharacters:
^       Matches the starting position within the string
$       Matches the ending position of the string just before newline
.       Matches any single character 
[a-z]   Matches the pattern contained within the brackets
[^a]    Matches a single character that is not contained within the brackets
[a|b]   Matches the character a or b
?       Matches the preceding element zero or more times
+       one or more occurrences of the preceding element
a{1,20} Matches the preceding element at least 1 and not more than 20 times
\       read the following metacharacter as a character
'''
p=re.compile('[0-9]{2,4}') #save regex pattern, use it to save memory
re.search('\[.+?\]' s).group(); #return object with 1st occurrence found 
re.sub('[0-9]{2,4}','NUM', s); #return string with all substitutions
Ar=re.findall(re.compile('[0-9]{2,4}'), s) #return array of values matched in string
Ar=re.split(re.compile('[0-9]{2,4}'), s) #return array of elements splitted by pattern
if not re.search('[0-9]{2,4}', s): #check if not matched
 print('no match')
else:
 print('match found')

#pandas i/o and data manipulation
d=pd.read_clipboard(sep=','); #imports from clipboard
d=pd.read_csv(r'E:\work\apps\wheather.csv', sep=','); #imports csv in a dataframe
d.head(); #gives 5 line preview with header
list(d); #gives header with attribute names
d.iloc[0]; #gives header and values of the instance at index
d['outlook'].describe(); #summary of specific attribute
d['outlook'].astype(str) + d['notes']; #combine strings into one
d.corr(); #finds correlations between the numeric attributes
d.count(); #counts the values that are present
d.groupby('humidity').count(); #frequency table as nominal values for all values grouped by one attribute 
d.groupby('play').sum(); #frequency table for numeric values summed by one attribute
d.groupby('play').mean(); #frequency table for numeric values averaged by one attribute
d['outlook'].astype('category').value_counts(); #frequency list of single attribute
d2=d.loc[:, 'temperature':'humidity':1]; #slice dataframe from:to:every
d.sample(frac=0.5, replace=0); #resample the data with or without replacement
d['date']=pd.to_datetime(d.date); fdate=d['date'].dt.strftime('%m/%d/%Y'); #format dates %d=day, %a=wday, %b=month, %Y=year4 %H=hour %p=AM/PM
d['fdate']=fdate.values #add column to frame
d2=pd.DataFrame(d.loc[d['outlook']=='rainy'].values); #extract subset by attribute value
d3=pd.get_dummies(d); #extract boolean attributes from nominal values
print(d.groupby('action').count().to_csv(), file=open("py.csv", "w")); #export in a file

#mathplotlib
d['temperature'].plot.density(bw_method=None, ind=None); mp.show(); #plot density curve of an attribute
fig=mp.figure(); ax=Axes3D(fig); ax.scatter(d['temperature'], d['outlook'], d['play']); #3d scatterplot of multiple attributes

#stats
t,pval=st.ttest_1samp(a=p['a8'], popmean=p['a7'].mean()); #t-test: t=measures the difference between a numerical sample and a mean of a population
chi,pval=st.chisquare(p['a0'], p['a1']); #chi2 test: measures the distance between a numerical sample and a model of that sample
k2, pval = st.normaltest(p['a0']); #normaltest: measure the distance of a numerical sample from a normal distribution
kurt,pval=st.kurtosistest(p['a7']); #kurtosistest: measures the difference of the kurtosis from a normal one in numerical samples
corr,pval=st.spearmanr(p['a8'], p['a7']); #correlation test: measures how much 2 samples move together directly (+1) or inversely (-1)
u,pval=st.mannwhitneyu(p['a8'],p['a7']); #mann U test: measures how much two independent samples were selected from populations having the same distribution
anovak,pval=st.kruskal(p['a0'], p['a0'], p['a1'], p['a6'], p['a7']); #kruskal ANOVA test: measures whether at least one num sample stochastically dominates other num sample


